<?php
$sql = "SHOW TABLES LIKE '".DB_PREFIX."epochta_settings'";
$result = $this->db->query($sql);

// if table exists
if ( ! empty($result->row)) {
    $sql = "SHOW CREATE TABLE `".DB_PREFIX."epochta_settings`";
    $result = $this->db->query($sql);
    if (isset($result->row['Create Table'])) {
        // check structure
        $valid_sql = "CREATE TABLE `".DB_PREFIX."epochta_settings` (
  `code` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8";
        // drop invalid table with invalid structure
        if ($result->row['Create Table'] !== $valid_sql) {
            $sql = "DROP TABLE `".DB_PREFIX."epochta_settings`";
            $this->db->query($sql);
        }
    }
}

$sql = "
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."epochta_settings` (
  `code` varchar(255) CHARACTER SET utf8 NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`code`)
) ENGINE=MyIsam DEFAULT CHARSET=utf8";
$this->db->query($sql);

// reinstall default settings
$sql = "
SELECT * 
FROM  `".DB_PREFIX."epochta_settings` 
WHERE  `code` = 'sender_name'
LIMIT 0,1";
$result = $this->db->query($sql);
if ( ! isset($result->row['code'])) {
    $sql = "
    INSERT INTO `".DB_PREFIX."epochta_settings` (`code`, `value`) VALUES
    ('sender_name', 'EpochtaInfo'),
    ('public_key', 'your_public_key'),
    ('private_key', 'your_privat_key');";
    $this->db->query($sql);
}

/**
ALTER TABLE `oc_epochta_settings`
  DROP `public_key`,
  DROP `private_key`;
ALTER TABLE  `oc_epochta_settings` CHANGE  `sms_alias`  `value` VARCHAR( 11 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE  `oc_epochta_settings` CHANGE  `value`  `value` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
*/

$sql = "
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."order_sms_history` (
  `order_history_id` int(11) NOT NULL AUTO_INCREMENT,
  `order_id` int(11) NOT NULL,
  `order_status_id` int(5) NOT NULL,
  `sms_status` varchar(32) NOT NULL,
  `comment` text NOT NULL,
  `date_added` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`order_history_id`)
) ENGINE=MyIsam  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";
$this->db->query($sql);

list($v1,$v2,$v3) = explode('.', VERSION);
$v1 = (int) $v1;
$v2 = (int) $v2;
$v3 = (int) $v3;

// >= 2.2 // https://github.com/opencart/opencart/wiki/Events-(script-notifications)-2.2.x.x
// 2.0 - 2.1 // https://github.com/opencart/opencart/wiki/Events-(script-notifications)-2.0.x.x-&-2.1.x.x
// if ($v1 >= 2 AND $v2 >= 0 AND $v2 < 2) {

if ($v1 >= 2 AND $v2 >= 2) { // > 2.1
    $this->load->model('extension/event');
    $this->model_extension_event->deleteEvent('event_epochta');
    $this->model_extension_event->addEvent('event_epochta', 'catalog/model/checkout/order/editOrder/after', 'sale/sms_sending/editOrder');
    $this->model_extension_event->addEvent('event_epochta', 'catalog/model/checkout/order/addOrder/after', 'sale/sms_sending/addOrder');
    // $this->model_extension_event->addEvent('event_epochta', 'admin/model/sale/order/deleteOrder/after', 'sale/sms_sending/deleteOrder');
    $this->model_extension_event->addEvent('event_epochta', 'admin/model/sale/order/deleteOrder/before', 'sale/sms_sending/deleteOrder');
    $this->model_extension_event->addEvent('event_epochta', 'catalog/model/checkout/order/addOrderHistory/after', 'sale/sms_sending/addOrderHistory');
    $this->model_extension_event->addEvent('event_epochta', 'admin/model/sale/return/addReturn/after', 'sale/sms_sending/addReturn');
    $this->model_extension_event->addEvent('event_epochta', 'admin/model/customer/customer/addCustomer/after', 'sale/sms_sending/addCustomer');
    $this->model_extension_event->addEvent('event_epochta', 'catalog/model/account/customer/addCustomer/after', 'sale/sms_sending/addCustomer');
    $this->model_extension_event->addEvent('event_epochta', 'admin/model/catalog/product/addProduct/after', 'sale/sms_sending/addProduct');
    $this->model_extension_event->addEvent('event_epochta', 'admin/model/catalog/product/editProduct/after', 'sale/sms_sending/editProduct');
    $this->model_extension_event->addEvent('event_epochta', 'catalog/model/catalog/product/editProduct/after', 'sale/sms_sending/editProduct');
} elseif($v1 == 2 AND $v2 == 0 AND $v3 == 0) { // == 2.0.0.0
    $this->load->model('tool/event');
    $this->model_tool_event->deleteEvent('event_epochta');
    $this->model_tool_event->addEvent('event_epochta', 'post.order.add', 'sale/sms_sending/postOrderAdd');
    $this->model_tool_event->addEvent('event_epochta', 'post.order.history.add', 'sale/sms_sending/postOrderHistoryAdd');
    $this->model_tool_event->addEvent('event_epochta', 'post.order.edit', 'sale/sms_sending/postOrderEdit');
    $this->model_tool_event->addEvent('event_epochta', 'pre.order.delete', 'sale/sms_sending/preOrderDelete');
    $this->model_tool_event->addEvent('event_epochta', 'post.admin.edit.product', 'sale/sms_sending/postAdminProductEdit');
    $this->model_tool_event->addEvent('event_epochta', 'post.admin.add.product', 'sale/sms_sending/postAdminProductAdd');
    $this->model_tool_event->addEvent('event_epochta', 'post.customer.add', 'sale/sms_sending/postCustomerAdd');
    $this->model_tool_event->addEvent('event_epochta', 'post.return.add', 'sale/sms_sending/postReturnAdd');
} elseif($v1 >= 2 AND $v2 >= 0 AND $v2 < 2 AND $v3 >= 0) { // >= 2.0.0.0
    $this->load->model('extension/event');
    $this->model_extension_event->deleteEvent('event_epochta');
    $this->model_extension_event->addEvent('event_epochta', 'post.order.add', 'sale/sms_sending/postOrderAdd');
    $this->model_extension_event->addEvent('event_epochta', 'post.order.history.add', 'sale/sms_sending/postOrderHistoryAdd');
    $this->model_extension_event->addEvent('event_epochta', 'post.order.edit', 'sale/sms_sending/postOrderEdit');
    $this->model_extension_event->addEvent('event_epochta', 'pre.order.delete', 'sale/sms_sending/preOrderDelete');
    $this->model_extension_event->addEvent('event_epochta', 'post.admin.edit.product', 'sale/sms_sending/postAdminProductEdit');
    $this->model_extension_event->addEvent('event_epochta', 'post.admin.add.product', 'sale/sms_sending/postAdminProductAdd');
    $this->model_extension_event->addEvent('event_epochta', 'post.customer.add', 'sale/sms_sending/postCustomerAdd');
    $this->model_extension_event->addEvent('event_epochta', 'post.return.add', 'sale/sms_sending/postReturnAdd');
}


/**
2.3.0.2-compiled - admin/model/extension/event.php; 
2.2.0.0-compiled - admin/model/extension/event.php; 
opencart-2.1.0.2 - admin/model/extension/event.php; $this->event->trigger('pre.order.add', $data);
opencart-2.1.0.1 - admin/model/extension/event.php; $this->event->trigger('pre.order.add', $data);
opencart-2.0.3.1 - admin/model/extension/event.php; $this->event->trigger('pre.order.add', $data);
opencart-2.0.2.0 - admin/model/extension/event.php; $this->event->trigger('pre.order.add', $data);
opencart-2.0.1.1 - admin/model/extension/event.php; $this->event->trigger('pre.order.add', $data);
opencart-2.0.0.0 - admin/model/tool/event.php; $this->event->trigger('pre.order.add', $data);
opencart-1.5.6.4 - - not supported
*/